#include <sys/types.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>

int main() {


  pid_t newpid;
  int fd1[2], fd2[2], fd3[2];

  char m0[] = "\n about to fork ..\n";
  char m1[] = "message 1\n";
  char m2[] = "message 2\n";
  char m3[] = "message 3\n";
  char m4[] = "\n done ..\n";

  char rbuf1[256];
  char rbuf2[256];
  char rbuf3[256];

  int cn1, cn2, cn3;

  if ((pipe(fd1)== -1)) printf(" error \n");
  if ((pipe(fd2)== -1)) printf(" error \n");
  if ((pipe(fd3)== -1)) printf(" error \n");

  if ((newpid = fork()) == -1) { printf("error \n"); return 0;}
  
  if (newpid > 0) {
  
    close(fd1[1]);
    close(fd2[1]);
    close(fd3[0]);
    write(8, m3, sizeof(m3));
    //    usleep(10000);
    cn1 = read(3, rbuf1, 256);
    cn2 = read(5,rbuf2,256);
    write(1, rbuf1, cn1);
    write(1, rbuf2, cn2);
    
  }
  else {
    close (fd1[0]);
    close (fd2[0]);
    close (fd3[1]);
    write(4, m1, sizeof(m1));
    usleep(10000);
    write(6,m2,sizeof(m2));
    usleep(10000);
    cn3 = read(7, rbuf3, 256);
    write(1, rbuf3,cn3);
  }
  usleep(10000); 
  write(2,m4,sizeof(m4));
 
  return 0;
}   



    
