
/* process creation in unix          */
/* Examples using system call fork  */

#include "myhdr.h"

main()
{
  int pid;

  printf(" Just one process so far\n");
  printf(" Calling fork() system call\n");

  pid = fork();  /* create new process*/

  if (pid == 0)
    { 
      printf(" I am the child \n");
      execl("/bin/ls", "ls", "-l", (char *)0);
      printf("exec failed \n");
    }
  else if (pid > 0)
    {
      wait((int *)0);
      printf(" I am the parent, ls has been completed \n");
 
    }
  else
    printf(" Fork returned an error %d \n", pid);
  return 0;
}
