#include <stdio.h>
#include <signal.h>
#define MYSIG 43

/* signal hanlder evoked by sig 44
   reinstalls after each sig hit, prints number of hits*/

void getsig(int s)// signal handler
{
  static int count = 0;
  printf("signal %d again, %dth time \n", s, ++count);
  signal(MYSIG, getsig); //reinstalling sig handler
}

int main(void)
{
  signal(MYSIG, getsig); // install signal handler
  printf("start counting keyboard kills\n");
  while(1) {};
  return 0;
}
